﻿using System;
using System.IO;
using System.Security.Cryptography;
using System.Text;

namespace nextWave.WDAC
{
	// Token: 0x02000009 RID: 9
	internal class Encryption
	{
		// Token: 0x0600004F RID: 79 RVA: 0x00003B6C File Offset: 0x00001D6C
		public string crypt(string key, string data)
		{
			string result = null;
			byte[][] hashKeys = this.GetHashKeys(key);
			try
			{
				result = Encryption.EncryptStringToBytes_Aes(data, hashKeys[0], hashKeys[1]);
			}
			catch (CryptographicException)
			{
			}
			catch (ArgumentNullException)
			{
			}
			return result;
		}

		// Token: 0x06000050 RID: 80 RVA: 0x00003BC0 File Offset: 0x00001DC0
		public string decrypt(string key, string data)
		{
			string result = null;
			byte[][] hashKeys = this.GetHashKeys(key);
			try
			{
				result = Encryption.DecryptStringToBytes_Aes(data, hashKeys[0], hashKeys[1]);
			}
			catch (CryptographicException)
			{
			}
			catch (ArgumentNullException)
			{
			}
			return result;
		}

		// Token: 0x06000051 RID: 81 RVA: 0x00003C14 File Offset: 0x00001E14
		private byte[][] GetHashKeys(string key)
		{
			byte[][] array = new byte[2][];
			Encoding utf = Encoding.UTF8;
			SHA256 sha = new SHA256CryptoServiceProvider();
			byte[] bytes = utf.GetBytes(key);
			byte[] bytes2 = utf.GetBytes(key);
			byte[] array2 = sha.ComputeHash(bytes);
			byte[] array3 = sha.ComputeHash(bytes2);
			Array.Resize<byte>(ref array3, 16);
			array[0] = array2;
			array[1] = array3;
			return array;
		}

		// Token: 0x06000052 RID: 82 RVA: 0x00003C74 File Offset: 0x00001E74
		private static string EncryptStringToBytes_Aes(string plainText, byte[] Key, byte[] IV)
		{
			bool flag = plainText == null || plainText.Length <= 0;
			if (flag)
			{
				throw new ArgumentNullException("plainText");
			}
			bool flag2 = Key == null || Key.Length == 0;
			if (flag2)
			{
				throw new ArgumentNullException("Key");
			}
			bool flag3 = IV == null || IV.Length == 0;
			if (flag3)
			{
				throw new ArgumentNullException("IV");
			}
			byte[] inArray;
			using (AesManaged aesManaged = new AesManaged())
			{
				aesManaged.Key = Key;
				aesManaged.IV = IV;
				ICryptoTransform transform = aesManaged.CreateEncryptor(aesManaged.Key, aesManaged.IV);
				using (MemoryStream memoryStream = new MemoryStream())
				{
					using (CryptoStream cryptoStream = new CryptoStream(memoryStream, transform, CryptoStreamMode.Write))
					{
						using (StreamWriter streamWriter = new StreamWriter(cryptoStream))
						{
							streamWriter.Write(plainText);
						}
						inArray = memoryStream.ToArray();
					}
				}
			}
			return Convert.ToBase64String(inArray);
		}

		// Token: 0x06000053 RID: 83 RVA: 0x00003DB8 File Offset: 0x00001FB8
		private static string DecryptStringToBytes_Aes(string cipherTextString, byte[] Key, byte[] IV)
		{
			byte[] array = Convert.FromBase64String(cipherTextString);
			bool flag = array == null || array.Length == 0;
			if (flag)
			{
				throw new ArgumentNullException("plainText");
			}
			bool flag2 = Key == null || Key.Length == 0;
			if (flag2)
			{
				throw new ArgumentNullException("Key");
			}
			bool flag3 = IV == null || IV.Length == 0;
			if (flag3)
			{
				throw new ArgumentNullException("IV");
			}
			string result = null;
			using (Aes aes = Aes.Create())
			{
				aes.Key = Key;
				aes.IV = IV;
				ICryptoTransform transform = aes.CreateDecryptor(aes.Key, aes.IV);
				using (MemoryStream memoryStream = new MemoryStream(array))
				{
					using (CryptoStream cryptoStream = new CryptoStream(memoryStream, transform, CryptoStreamMode.Read))
					{
						using (StreamReader streamReader = new StreamReader(cryptoStream))
						{
							result = streamReader.ReadToEnd();
						}
					}
				}
			}
			return result;
		}
	}
}
