﻿using System;
using System.Runtime.InteropServices;

namespace nextWave.WDAC.Utility
{
	// Token: 0x0200000F RID: 15
	internal class KnownFolders
	{
		// Token: 0x0600006F RID: 111 RVA: 0x00004AD0 File Offset: 0x00002CD0
		public static string GetPath(KnownFolder knownFolder)
		{
			return KnownFolders.GetPath(knownFolder, false);
		}

		// Token: 0x06000070 RID: 112 RVA: 0x00004AEC File Offset: 0x00002CEC
		public static string GetPath(KnownFolder knownFolder, bool defaultUser)
		{
			return KnownFolders.GetPath(knownFolder, KnownFolders.KnownFolderFlags.DontVerify, defaultUser);
		}

		// Token: 0x06000071 RID: 113 RVA: 0x00004B0C File Offset: 0x00002D0C
		private static string GetPath(KnownFolder knownFolder, KnownFolders.KnownFolderFlags flags, bool defaultUser)
		{
			IntPtr ptr;
			int num = KnownFolders.SHGetKnownFolderPath(new Guid(KnownFolders._knownFolderGuids[(int)knownFolder]), (uint)flags, new IntPtr(defaultUser ? -1 : 0), out ptr);
			bool flag = num >= 0;
			if (flag)
			{
				return Marshal.PtrToStringUni(ptr);
			}
			throw new ExternalException("Unable to retrieve the known folder path. It may not be available on this system.", num);
		}

		// Token: 0x06000072 RID: 114
		[DllImport("Shell32.dll")]
		private static extern int SHGetKnownFolderPath([MarshalAs(UnmanagedType.LPStruct)] Guid rfid, uint dwFlags, IntPtr hToken, out IntPtr ppszPath);

		// Token: 0x0400004F RID: 79
		private static string[] _knownFolderGuids = new string[]
		{
			"{56784854-C6CB-462B-8169-88E350ACB882}",
			"{B4BFCC3A-DB2C-424C-B029-7FE99A87C641}",
			"{FDD39AD0-238F-46AF-ADB4-6C85480369C7}",
			"{374DE290-123F-4565-9164-39C4925E467B}",
			"{1777F761-68AD-4D8A-87BD-30B759FA33DD}",
			"{BFB9D5E0-C6A9-404C-B2B2-AE6DB6AF4968}",
			"{4BD8D571-6D19-48D3-BE97-422220080E43}",
			"{33E28130-4E1E-4676-835A-98395C3BC3BB}",
			"{4C5C32FF-BB9D-43B0-B5B4-2D72E54EAAA4}",
			"{7D1D3A04-DEBB-4115-95CF-2F29DA2920DA}",
			"{18989B1D-99B5-455B-841C-AB7C74E4DDFC}",
			"{008ca0b1-55b4-4c56-b8a8-4de4b299d3be}",
			"{C4AA340D-F20F-4863-AFEF-F87EF2E6BA25}",
			"{3D644C9B-1FB8-4f30-9B45-F670235F79C0}"
		};

		// Token: 0x0200001B RID: 27
		[Flags]
		private enum KnownFolderFlags : uint
		{
			// Token: 0x0400006C RID: 108
			SimpleIDList = 256u,
			// Token: 0x0400006D RID: 109
			NotParentRelative = 512u,
			// Token: 0x0400006E RID: 110
			DefaultPath = 1024u,
			// Token: 0x0400006F RID: 111
			Init = 2048u,
			// Token: 0x04000070 RID: 112
			NoAlias = 4096u,
			// Token: 0x04000071 RID: 113
			DontUnexpand = 8192u,
			// Token: 0x04000072 RID: 114
			DontVerify = 16384u,
			// Token: 0x04000073 RID: 115
			Create = 32768u,
			// Token: 0x04000074 RID: 116
			NoAppcontainerRedirection = 65536u,
			// Token: 0x04000075 RID: 117
			AliasOnly = 2147483648u
		}
	}
}
