﻿using System;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Security.Cryptography;
using System.Threading;
using nextWave.WDAC.Utility;

namespace nextWave.WDAC
{
	// Token: 0x0200000A RID: 10
	internal class ModuleAnalysis
	{
        // Token: 0x06000055 RID: 85 RVA: 0x00003EF4 File Offset: 0x000020F4
        public ModuleAnalysis(string Proc)
        {
            Console.WriteLine("Starting Module analysis");
            this.Proc = Proc;
            CurrThread = new Thread(() => AntiModuleInjection());
            CurrThread.IsBackground = true;
            CurrThread.Start();
        }


        // Token: 0x06000056 RID: 86 RVA: 0x00004068 File Offset: 0x00002268
        public void AntiModuleInjection()
		{
			for (;;)
			{
				Process[] processesByName = Process.GetProcessesByName(this.Proc);
				while (processesByName.Length == 0)
				{
					Thread.Sleep(500);
				}
				this.BFH = processesByName[0];
				Console.WriteLine("In while true loop");
				ProcessModuleCollection modules = this.BFH.Modules;
				Console.WriteLine(modules.Count + " modules detected.");
				for (int i = 0; i < modules.Count; i++)
				{
					string[] source = modules[i].FileName.Split(new char[]
					{
						'\\'
					});
					string text = source.Last<string>();
					for (int j = 0; j < this.blacklistStrings.Length; j++)
					{
						bool flag = text.Contains(this.blacklistStrings[j]);
						if (flag)
						{
							Actions.BanUser(string.Concat(new object[]
							{
								"Blacklisted Module detected[name], name: ",
								modules[i].FileName,
								" TIME: ",
								DateTime.UtcNow
							}), Controller.user, Controller.HWID);
						}
					}
					for (int k = 0; k < this.blacklistMD5s.Length; k++)
					{
						bool flag2 = this.CalculateMD5(modules[i].FileName) == this.blacklistMD5s[k];
						if (flag2)
						{
							Actions.BanUser(string.Concat(new object[]
							{
								"Blacklisted MD5 detected[md5], name: ",
								modules[i].FileName,
								" TIME: ",
								DateTime.UtcNow
							}), Controller.user, Controller.HWID);
						}
					}
				}
				Thread.Sleep(20000);
			}
		}

		// Token: 0x06000057 RID: 87 RVA: 0x00004243 File Offset: 0x00002443
		public static void Abort()
		{
			ModuleAnalysis.CurrThread.Abort();
		}

		// Token: 0x06000058 RID: 88 RVA: 0x00004254 File Offset: 0x00002454
		public string CalculateMD5(string filename)
		{
			string result;
			using (MD5 md = MD5.Create())
			{
				using (FileStream fileStream = File.OpenRead(filename))
				{
					byte[] value = md.ComputeHash(fileStream);
					result = BitConverter.ToString(value).Replace("-", "").ToLowerInvariant();
				}
			}
			return result;
		}

		// Token: 0x04000042 RID: 66
		private string[] blacklistStrings = new string[]
		{
			"$5",
			"5$",
			"cheat",
			"hacks",
			"hack",
			"aimbot",
			"wallhack",
			"unknowncheats",
			"Xenos",
			"Injector",
			"Winjector",
			"OSHFusionLoader",
			"SilentInject",
			"ExtremeInjector",
			"revivehack",
			"awakenhack",
			"risinghack",
			"revhack",
			"reviahhack",
			"Xenos",
			"5$BFH",
			"BFH5$"
		};

		// Token: 0x04000043 RID: 67
		private string[] blacklistMD5s = new string[]
		{
			"358e364d9b52dfb4d8e2584aea928c9d",
			"68d5890bfe94a36dd715d1d51d4b9167",
			"044732e02df12228eee00c3a7ee7dda4",
			"82cdc74cae5a83a292b55dab1fa9a96d",
			"ee68efc16b602c688e5c14ac40bd1a19",
			"b2bd45bae8c6dcc328f2633d33c7116c",
			"ade9f7ae144ba42a79fa8949549e771d",
			"4c04a5b1e822acc5286193c5768fd7b6",
			"661b304e32edff535d7793a547f026fb"
		};

		// Token: 0x04000044 RID: 68
		private string Proc;

		// Token: 0x04000045 RID: 69
		private Process BFH;

		// Token: 0x04000046 RID: 70
		public bool running;

		// Token: 0x04000047 RID: 71
		public static Thread CurrThread;
	}
}
